    #include <stdio.h>
    #include <stdlib.h>
    #include <pthread.h>
    #include <signal.h>
    #include <string.h>
    #include <errno.h>

    static sigset_t   signal_mask;  /* signals to block         */

    void *signal_thread (void *arg);

    int main (int argc, char *argv[])
    {
        pthread_t  sig_thr_id;      /* signal handler thread ID */
        int        rc;              /* return code              */
        void *thread_result;

        sigemptyset (&signal_mask);
        sigaddset (&signal_mask, SIGINT);
        sigaddset (&signal_mask, SIGTERM);
        rc = pthread_sigmask (SIG_BLOCK, &signal_mask, NULL);
        if (rc != 0) {
            /* handle error */
            printf("Sigmask Error\n");
            exit(EXIT_FAILURE);
        }
        /* any newly created threads inherit the signal mask */


        rc = pthread_create (&sig_thr_id, NULL, signal_thread, NULL);
        if (rc != 0) {
            /* handle error */
            printf("Pthread Create Error\n");
            exit(EXIT_FAILURE);
        }
        rc = pthread_join(sig_thr_id, &thread_result);
        if (rc != 0) {
            perror("Thread join failed");
            exit(EXIT_FAILURE);
        }

    }


    void *signal_thread (void *arg)
    {
        int       sig_caught;    /* signal caught       */
        int       rc;            /* returned code       */


        rc = sigwait (&signal_mask, &sig_caught);
        if (rc != 0) {
            /* handle error */
        }
        switch (sig_caught)
        {
        case SIGINT:     /* process SIGINT  */
            printf("SIGINT processing...\n");
            break;
        case SIGTERM:    /* process SIGTERM */
            printf("SIGTERM processing...\n");            break;
        default:         /* should normally not happen */
            fprintf (stderr, "\nUnexpected signal %d\n", sig_caught);
            break;
        }
        pthread_exit("Thank you for the CPU time");
    }

