#define _REENTRANT

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

#include <signal.h>
#include <time.h>
#include <errno.h>
#include <string.h>


void *thread_function1(void *arg);
void *thread_function2(void *arg);

int main() {
    int res;
    pthread_t a_thread;
    void *thread_result;
    sigset_t set;

    (void) sigemptyset(&set);
	(void) sigaddset(&set, SIGRTMIN);
	(void) sigaddset(&set, SIGRTMIN+1);
	(void) pthread_sigmask(SIG_BLOCK, &set, NULL);

    res = pthread_create(&a_thread, NULL, thread_function1, NULL);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }

    res = pthread_create(&a_thread, NULL, thread_function2, NULL);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }

    printf("Waiting for thread to finish...\n");
    res = pthread_join(a_thread, &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }
    printf("Waiting for thread to finish...\n");
    res = pthread_join(a_thread, &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}

void *thread_function1(void *arg) {
    struct sigevent ev;
	struct itimerspec ts;
	sigset_t set;
	timer_t tid;
	char *cmd = "XXX";
	int signum;

	ev.sigev_notify = SIGEV_SIGNAL;
	ev.sigev_signo = SIGRTMIN;

	if (timer_create(CLOCK_REALTIME, &ev, &tid) == -1) {
		(void) fprintf(stderr, "%s: cannot create CLOCK_HIGHRES "
		    "timer: %s\n", cmd, strerror(errno));
		exit(EXIT_FAILURE);
	}

	(void) sigemptyset(&set);
	(void) sigaddset(&set, SIGRTMIN);
	(void) pthread_sigmask(SIG_BLOCK, &set, NULL);

	ts.it_value.tv_sec = 1;
	ts.it_value.tv_nsec = 0;
	ts.it_interval.tv_sec = 1;
	ts.it_interval.tv_nsec = 0;

	if (timer_settime(tid, TIMER_ABSTIME, &ts, NULL) == -1) {
		(void) fprintf(stderr, "%s: timer_settime() failed: %s\n",
		    cmd, strerror(errno));
		exit(EXIT_FAILURE);
	}

	for (;;) {
		(void) sigwait(&set,&signum);
		printf("Hello 1\n");
	}

	/*NOTREACHED*/
    pthread_exit("Thank you for the CPU time");
}

void *thread_function2(void *arg) {
    struct sigevent ev;
	struct itimerspec ts;
	sigset_t set;
	timer_t tid;
	char *cmd = "XXX";
	int signum;

	ev.sigev_notify = SIGEV_SIGNAL;
	ev.sigev_signo = SIGRTMIN+1;

	if (timer_create(CLOCK_REALTIME, &ev, &tid) == -1) {
		(void) fprintf(stderr, "%s: cannot create CLOCK_HIGHRES "
		    "timer: %s\n", cmd, strerror(errno));
		exit(EXIT_FAILURE);
	}

	(void) sigemptyset(&set);
	(void) sigaddset(&set, SIGRTMIN+1);
	(void) pthread_sigmask(SIG_BLOCK, &set, NULL);

	ts.it_value.tv_sec = 1;
	ts.it_value.tv_nsec = 0;
	ts.it_interval.tv_sec = 3;
	ts.it_interval.tv_nsec = 0;

	if (timer_settime(tid, TIMER_ABSTIME, &ts, NULL) == -1) {
		(void) fprintf(stderr, "%s: timer_settime() failed: %s\n",
		    cmd, strerror(errno));
		exit(EXIT_FAILURE);
	}

	for (;;) {
		(void) sigwait(&set,&signum);
		printf("Hello2\n");
	}

	/*NOTREACHED*/
    pthread_exit("Thank you for the CPU time");
}

